=== debian/changelog ===
tcc (0.9.26~git20110616.330d2ee-4) experimental; urgency=low

  * Replace old patch fixing Hurd FTBFS by the one accepted upstream.
  * Insert missing changelog for tcc 0.9.25-9.
  * Stop wrongly using multiarch dynamic loader as elf interpreter (eg. back
    to use /lib64/ld-linux-x86-64.so.2 for amd64).

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 31 Jul 2011 21:43:49 +0200

tcc (0.9.26~git20110616.330d2ee-3) experimental; urgency=low

  * Use any-i386 and any-amd64 instead of hardcoded list of architectures.
  * Fix Hurd FTBFS by forcing expr_cond to only consider constant expression
    outside functions.

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 31 Jul 2011 13:49:20 +0200

tcc (0.9.25-9) unstable; urgency=low

  * Stop exporting tcc_add_file2(), tcc_add_sysfile() and
    tcc_add_syslibrary_path() functions added for multiarch transitions.
  * Use any-i386 and any-amd64 instead of hardcoded list of architectures.

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 24 Jul 2011 21:27:09 +0200

tcc (0.9.26~git20110616.330d2ee-2) experimental; urgency=low

  * Don't define strtof and strtold on Debian GNU/kFreeBSD (fix FTBFS).

 -- Thomas Preud'homme <robotux@celest.fr>  Fri, 15 Jul 2011 18:16:26 +0200

tcc (0.9.26~git20110616.330d2ee-1) experimental; urgency=low

  * New upstream snapshot:
    + Fix design of previous VLA implementation
    + Allow jumps > 32MB for -run on ARM. (Closes: #592618)

  * debian/patches:
    + Remove all merged patches
    + Add 0001-Default-to-create-progs-with-symbols-incl.-debug.patch:
      create unstripped program with debug infos.
    + Add 0002-Make-ex1.c-and-ex4.c-be-executable-on-any-systems.patch

  * debian/copyright:
    + document origin of source code.

  * debian/rules:
    + Use dpkg-buildflags to set build flags (CPPFLAGS, CFLAGS and LDFLAGS).
    + Only call dh_auto_clean if config.mak exists.
    + Keep tcc directory in /usr/lib/tcc.

  * Point Vcs-* to anonscm.debian.org.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 12 Jul 2011 16:59:57 +0200

tcc (0.9.25-8) unstable; urgency=low

  * Modify debian/rules to use patch added in 0.9.25-7 (Closes: #632089).
  * Get DEB_HOST_MULTIARCH from dpkg-architecture to ensure it is set when
    calling debian/rules manually.
  * Fix build failure on i386: array_test should not define any parameter.
  * Make patch for multilib consistent with regards to the filenames opened.

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 11 Jul 2011 14:22:57 +0200

tcc (0.9.25-7) unstable; urgency=medium (fix #632089)

  * Search system files and library in multilib path (Closes: #632089).

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 10 Jul 2011 17:22:36 +0200
