## tcc 0.9.26~git20120104.83d57c0

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,6 @@
 TOP ?= .
 include $(TOP)/config.mak
 
-CFLAGS+=-g -Wall
 CFLAGS_P=$(CFLAGS) -pg -static -DCONFIG_TCC_STATIC
 LIBS_P=
 
@@ -158,12 +157,17 @@
 
 # Cross Tiny C Compilers
 %-tcc$(EXESUF):
-	$(CC) -o $@ tcc.c $(DEFINES) $(CFLAGS) $(LIBS) $(LDFLAGS)
-
-$(I386_CROSS): DEFINES = -DTCC_TARGET_I386 -DCONFIG_TCCDIR="\"$(tccdir)/i386\""
+	$(CC) -o $@ tcc.c -DONE_SOURCE $(DEFINES) $(CFLAGS) $(LIBS) $(LDFLAGS)
+
+$(I386_CROSS): DEFINES = -DTCC_TARGET_I386 \
+    -DCONFIG_TCCDIR="\"$(tccdir)/i386\""
 $(X64_CROSS): DEFINES = -DTCC_TARGET_X86_64
-$(WIN32_CROSS): DEFINES = -DTCC_TARGET_I386 -DTCC_TARGET_PE -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" -DCONFIG_TCC_CROSSLIB="\"lib/32\""
-$(WIN64_CROSS): DEFINES = -DTCC_TARGET_X86_64 -DTCC_TARGET_PE -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" -DCONFIG_TCC_CROSSLIB="\"lib/64\""
+$(WIN32_CROSS): DEFINES = -DTCC_TARGET_I386 -DTCC_TARGET_PE \
+    -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" \
+    -DCONFIG_TCC_LIBPATHS="\"{B}/lib/32;{B}/lib\""
+$(WIN64_CROSS): DEFINES = -DTCC_TARGET_X86_64 -DTCC_TARGET_PE \
+    -DCONFIG_TCCDIR="\"$(tccdir)/win32\"" \
+    -DCONFIG_TCC_LIBPATHS="\"{B}/lib/64;{B}/lib\""
 $(WINCE_CROSS): DEFINES = -DTCC_TARGET_PE
 $(C67_CROSS): DEFINES = -DTCC_TARGET_C67
 $(ARM_FPA_CROSS): DEFINES = -DTCC_TARGET_ARM
@@ -180,14 +184,13 @@
 $(ARM_FPA_CROSS) $(ARM_FPA_LD_CROSS) $(ARM_VFP_CROSS) $(ARM_EABI_CROSS): $(ARM_FILES)
 
 # libtcc generation and test
-ifdef NOTALLINONE
+ifndef ONE_SOURCE
 LIBTCC_OBJ = $(filter-out tcc.o,$(patsubst %.c,%.o,$(filter %.c,$(NATIVE_FILES))))
 LIBTCC_INC = $(filter %.h,$(CORE_FILES)) $(filter-out $(CORE_FILES),$(NATIVE_FILES))
-$(LIBTCC_OBJ) tcc.o : NATIVE_DEFINES += -DNOTALLINONE
 else
 LIBTCC_OBJ = libtcc.o
 LIBTCC_INC = $(NATIVE_FILES)
-tcc.o : NATIVE_DEFINES += -DNOTALLINONE
+$(LIBTCC_OBJ) tcc.o : NATIVE_DEFINES += -DONE_SOURCE
 endif
 
 $(LIBTCC_OBJ) tcc.o : %.o : %.c $(LIBTCC_INC)
@@ -217,12 +220,17 @@
 lib/%/libtcc1.a : FORCE $(PROGS_CROSS)
 	@$(MAKE) -C lib cross TARGET=$*
 bcheck.o : lib/bcheck.c
-	gcc -c $< -o $@ -O2 -Wall
+	gcc -c $< -o $@ $(CFLAGS)
 FORCE:
 
 # install
 TCC_INCLUDES = stdarg.h stddef.h stdbool.h float.h varargs.h tcclib.h
 INSTALL=install
+ifdef STRIP_BINARIES
+INSTALLBIN=$(INSTALL) -s
+else
+INSTALLBIN=$(INSTALL)
+endif
 
 ifndef CONFIG_WIN32
 install: $(PROGS) $(TCCLIBS) $(TCCDOCS)
@@ -230,7 +238,7 @@
 ifeq ($(CC),tcc)
 	$(INSTALL) -m755 $(PROGS) "$(bindir)"
 else
-	$(INSTALL) -s -m755 $(PROGS) "$(bindir)"
+	$(INSTALLBIN) -m755 $(PROGS) "$(bindir)"
 endif
 	mkdir -p "$(mandir)/man1"
 	-$(INSTALL) tcc.1 "$(mandir)/man1"
@@ -291,7 +299,7 @@
 	mkdir -p "$(tccdir)/examples"
 	mkdir -p "$(tccdir)/doc"
 	mkdir -p "$(tccdir)/libtcc"
-	$(INSTALL) -s -m755 $(PROGS) "$(tccdir)"
+	$(INSTALLBIN) -m755 $(PROGS) "$(tccdir)"
 	$(INSTALL) -m644 $(LIBTCC1) win32/lib/*.def "$(tccdir)/lib"
 	cp -r win32/include/. "$(tccdir)/include"
 	cp -r win32/examples/. "$(tccdir)/examples"
