=== tests/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 # run local version of tcc with local libraries and includes
 TCC = ../tcc -B..
-RUN_TCC = $(NATIVE_DEFINES) -run ../tcc.c -B..
+RUN_TCC = $(NATIVE_DEFINES) -run -DONE_SOURCE ../tcc.c -B..
 DISAS=objdump -d
 
 all test : $(TESTS)
