=== debian/changelog ===
tcc (0.9.26~git20120104.83d57c0-2) experimental; urgency=low

  * Fix armel FTBFS by not compiling tccasm.c, as inline assembly is not
    supported on armel (Closes: #654904).

 -- Thomas Preud'homme <robotux@celest.fr>  Fri, 06 Jan 2012 18:37:50 +0100

tcc (0.9.26~git20120104.83d57c0-1) experimental; urgency=low

  * New upstream snapshot:
    + Make tcc search crt*.o files at the right location (Closes: #654631).
    + Incorporate the fix for linkage of named file in loader script
      (Closes: #654528).
  * debian/control:
    + Convert libtcc-dev to multiarch.
  * debian/rules:
    + Adapt to the new upstream build system.

 -- Thomas Preud'homme <robotux@celest.fr>  Thu, 05 Jan 2012 15:45:51 +0100

tcc (0.9.25-13) unstable; urgency=low

  * Fix linkage of named file in loader script (Closes: #654528).

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 04 Jan 2012 16:50:01 +0100

tcc (0.9.25-12) unstable; urgency=medium

  * Correct size_t and ptrdiff_t type on amd64 (Closes: #654436).

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 04 Jan 2012 11:30:56 +0100

tcc (0.9.25-11) unstable; urgency=medium

  * Change ELF interpreter from /lib/ld-linux-x86-64.so.2 — contrary to what
    announces previous entry — to /lib64/ld-linux-x86-64.so.2
    (Closes: #653941).

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 03 Jan 2012 15:53:32 +0100

tcc (0.9.25-10) unstable; urgency=medium

  * Stop wrongly using multiarch dynamic loader as elf interpreter, eg. back
    to use /lib64/ld-linux-x86-64.so.2 for amd64 (Closes: #636541).

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 03 Aug 2011 18:04:35 +0200
