=== tests/Makefile ===
--- 
+++ 
@@ -16,6 +16,12 @@
 
 ifdef DISABLE_STATIC
 export LD_LIBRARY_PATH:=$(CURDIR)/..
+endif
+
+ifeq ($(TARGETOS),Darwin)
+CFLAGS+=-Wl,-flat_namespace,-undefined,warning
+export MACOSX_DEPLOYMENT_TARGET:=10.2
+NATIVE_DEFINES+=-D_ANSI_SOURCE
 endif
 
 # run local version of tcc with local libraries and includes
@@ -45,7 +51,7 @@
 # test.ref - generate using gcc
 # copy only tcclib.h so GCC's stddef and stdarg will be used
 test.ref: tcctest.c
-	cp -u ../include/tcclib.h .
+	cp ../include/tcclib.h .
 	$(CC) -o tcctest.gcc $< -I. -w $(CFLAGS) -std=gnu99
 	./tcctest.gcc > $@
