=== debian/changelog ===
tcc (0.9.26~git20120612.ad5f375-6) unstable; urgency=low

  [Paul Tagliamonte]
    * Uploading Tom's fixes on his behalf. Although he's signed this upload
      (he issued a debdiff), I've prepared this upload. Fix verified on
      i386.

  [Thomas Preud'homme]
    * debian/patches:
      + Fix incorrect reading of long long values on architecture with 32bits
        registers like i386 and armel (Closes: #681281).

 -- Thomas Preud'homme <robotux@celest.fr>  Sat, 21 Jul 2012 03:43:35 +0200

tcc (0.9.26~git20120612.ad5f375-5) unstable; urgency=low

  * debian/patches:
    + Correctly handle integer promotion in patch fixing incorrect shift
      result type (Closes: #679123).
  * debian/control:
    + Set myself as Maintainer instead of Aurélien Gérôme as a result of him
      being MIA (Closes: #677782).

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 08 Jul 2012 17:36:15 +0200

tcc (0.9.26~git20120612.ad5f375-4) unstable; urgency=low

  * debian/patches:
    + Cherry-pick patch fixing incorrect shift result type (Closes: #679123).
  * debian/control:
    + Update Vcs-Browser URL.

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 27 Jun 2012 15:14:25 +0200

tcc (0.9.26~git20120612.ad5f375-3) unstable; urgency=low

  * debian/patches:
    + Disable the new callsave_test test on arm since it uses alloca which is
      not supported on arm (yet).

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 13 Jun 2012 22:31:30 +0200

tcc (0.9.26~git20120612.ad5f375-2) unstable; urgency=low

  * debian/patches:
    + Correctly handle multiarch on Kfreebsd and Hurd.

 -- Thomas Preud'homme <robotux@celest.fr>  Wed, 13 Jun 2012 18:34:11 +0200

tcc (0.9.26~git20120612.ad5f375-1) unstable; urgency=low

  * New upstream snapshot
  * debian/patches:
    + Fix R_ARM_REL32 relocation.
    + Expands arguments of configure script in order to accept ${prefix}.
  * debian/control:
    + Remove initial capital in package synopsis.
    + Update build dependency version on debhelper to reflect compatibility.
  * debian/rules:
    + Adapt to new upstream build system.
    + Remove build flags export as debhelper already does it.
    + Remove useless comments.
  * Bump compatibility to 9.
  * Add lintian overrides:
    + Upstream explicitly disable functions fortification, so do we.
    + Scripts in /usr/share/doc/tcc/examples are examples and need thus to be
      modified before used.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 12 Jun 2012 18:06:17 +0200

tcc (0.9.26~git20120104.83d57c0-5) unstable; urgency=low

  * Document that -b is only available on i386 (Closes: #663692).
  * Correctly parse unsigned long constants (ex: 1UL) on amd64
    (Closes: #663711).
  * Support arguments to linker options to be passed in separate linker
    options as in -Wl,-rpath -Wl,<somedir> (Closes: #663693).

 -- Thomas Preud'homme <robotux@celest.fr>  Thu, 15 Mar 2012 00:39:47 +0100

tcc (0.9.26~git20120104.83d57c0-4) unstable; urgency=low

  * Upload to unstable.

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 06 Mar 2012 00:19:03 +0100

tcc (0.9.26~git20120104.83d57c0-3) experimental; urgency=low

  * Fix typo of an error about unknown size with bounded pointer arithmetic
    (Closes: #655110, thanks Urs Janssen).
  * Fix loading of LLOCAL floats (Closes: #656995).
  * Use version 1.0 for DEP5 copyright.
  * Bump Standards-Version to 3.9.3 (no changes needed).

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 05 Mar 2012 23:13:42 +0100
