=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	dh_auto_configure -- --tccdir=../tcc

override_dh_auto_clean:
	[ ! -f config.mak ] || dh_auto_clean

clean:
	rm -f build
	dh clean

build:
	dh build
	touch build # As recommended by policy §4.9

%:
	dh $@
