=== debian/watch ===
version=3

http://download.savannah.nongnu.org/releases/tinycc/tcc-([\d\.]+).tar.bz2 debian uupdate
